-- /Users/philip/allacrost/demo/dat/maps/lua

local ns = {}
setmetatable(ns, {__index = _G})
demo_town = ns;
setfenv(1, ns);

-- A reference to the C++ MapMode object that was created with this file
map = {}

-- The map name and location graphic
map_name = "Village"
location_filename = "mountain_village.png"

-- The number of rows and columns of tiles that compose the map
num_tile_cols = 60
num_tile_rows = 40

-- The sound files used on this map.
sound_filenames = {}

-- The music files used as background music on this map.
music_filenames = {}
music_filenames[1] = "mus/Town_Folk.ogg"

-- The names of the tilesets used, with the path and file extension omitted
tileset_filenames = {}
tileset_filenames[1] = "mountain_landscape"
tileset_filenames[2] = "mountain_house_exterior"
tileset_filenames[3] = "mountain_house_exterior2"

enemy_ids = {}

-- The map grid to indicate walkability. The size of the grid is 4x the size of the tile layer tables
-- Walkability status of tiles for 32 contexts. Zero indicates walkable. Valid range: [0:2^32-1]
map_grid = {}
map_grid[0] = { 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[1] = { 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[2] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[3] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[4] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[5] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[6] = { 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[7] = { 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[8] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[9] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[10] = { 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[11] = { 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[12] = { 0, 0, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[13] = { 0, 0, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[14] = { 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0 }
map_grid[15] = { 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0 }
map_grid[16] = { 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0 }
map_grid[17] = { 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0 }
map_grid[18] = { 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0 }
map_grid[19] = { 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0 }
map_grid[20] = { 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1 }
map_grid[21] = { 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1 }
map_grid[22] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1 }
map_grid[23] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1 }
map_grid[24] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0 }
map_grid[25] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0 }
map_grid[26] = { 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1 }
map_grid[27] = { 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1 }
map_grid[28] = { 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1 }
map_grid[29] = { 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1 }
map_grid[30] = { 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[31] = { 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[32] = { 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0 }
map_grid[33] = { 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0 }
map_grid[34] = { 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[35] = { 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[36] = { 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[37] = { 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[38] = { 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[39] = { 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[40] = { 0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0 }
map_grid[41] = { 0, 0, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0 }
map_grid[42] = { 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[43] = { 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1 }
map_grid[44] = { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[45] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[46] = { 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[47] = { 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[48] = { 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[49] = { 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[50] = { 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[51] = { 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[52] = { 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1 }
map_grid[53] = { 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1 }
map_grid[54] = { 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1 }
map_grid[55] = { 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0 }
map_grid[56] = { 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0 }
map_grid[57] = { 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0 }
map_grid[58] = { 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[59] = { 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0 }
map_grid[60] = { 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 0, 0, 0 }
map_grid[61] = { 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0 }
map_grid[62] = { 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0 }
map_grid[63] = { 1, 1, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0 }
map_grid[64] = { 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0 }
map_grid[65] = { 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0 }
map_grid[66] = { 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0 }
map_grid[67] = { 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0 }
map_grid[68] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0 }
map_grid[69] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0 }
map_grid[70] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0 }
map_grid[71] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0 }
map_grid[72] = { 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0 }
map_grid[73] = { 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0 }
map_grid[74] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0 }
map_grid[75] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0 }
map_grid[76] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0 }
map_grid[77] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0 }
map_grid[78] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0 }
map_grid[79] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0 }

-- The lower tile layer. The numbers are indeces to the tile_mappings table.
lower_layer = {}
lower_layer[0] = { 10, 10, 10, 10, 10, 10, 111, 12, 13, 95, 78, 95, 11, 110, 42, 111, 110, 26, 26, 78, 78, 111, 13, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 111, 110, 78, 78, 26, 10, 10, 10, 10, 111, 12, 13, 94, 78, 95, 95, 78 }
lower_layer[1] = { 78, 78, 78, 78, 78, 10, 10, 10, 111, 13, 95, 78, 27, 10, 26, 42, 42, 78, 78, 78, 78, 78, 29, 78, 78, 78, 78, 78, 78, 78, 79, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 10, 10, 111, 12, 13, 95, 11, 13 }
lower_layer[2] = { 78, 78, 78, 78, 78, 78, 78, 10, 10, 111, 12, 13, 27, 10, 10, 10, 78, 78, 78, 78, 78, 78, 111, 12, 12, 13, 78, 78, 11, 12, 12, 13, 11, 12, 110, 10, 10, 10, 10, 10, 10, 10, 10, 78, 78, 95, 95, 78, 78, 78, 78, 78, 78, 78, 78, 10, 111, 13, 43, 45 }
lower_layer[3] = { 78, 78, 78, 78, 78, 78, 78, 78, 10, 10, 10, 111, 110, 42, 10, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 111, 12, 12, 110, 10, 10, 111, 110, 78, 78, 78, 78, 78, 78, 78, 78, 10, 10, 10, 13, 95, 95, 95, 79, 79, 27, 10, 78, 78, 78, 10, 10, 111, 13, 95 }
lower_layer[4] = { 78, 78, 78, 78, 78, 78, 78, 78, 10, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 42, 10, 10, 42, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 42, 42, 111, 12, 13, 95, 79, 11, 110, 10, 10, 10, 10, 10, 127, 126, 29, 78 }
lower_layer[5] = { 78, 78, 78, 79, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 42, 42, 111, 12, 12, 110, 127, 44, 126, 10, 10, 78, 111, 110, 29, 78 }
lower_layer[6] = { 78, 79, 79, 79, 78, 79, 78, 78, 78, 78, 78, 78, 78, 78, 78, 95, 78, 79, 78, 79, 95, 78, 95, 95, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 42, 42, 42, 111, 13, 27, 28, 10, 78, 10, 10, 29, 78 }
lower_layer[7] = { 78, 78, 79, 79, 79, 78, 78, 78, 78, 78, 78, 78, 78, 78, 95, 78, 95, 78, 79, 78, 79, 79, 79, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 79, 78, 79, 95, 95, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 111, 110, 28, 10, 78, 78, 10, 111, 12 }
lower_layer[8] = { 78, 78, 79, 79, 78, 79, 78, 78, 78, 78, 79, 78, 11, 12, 13, 78, 79, 78, 78, 79, 78, 79, 78, 79, 79, 95, 78, 78, 78, 78, 79, 78, 79, 95, 79, 79, 79, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 127, 126, 10, 78, 78, 78, 10, 10 }
lower_layer[9] = { 78, 78, 78, 79, 79, 11, 12, 12, 12, 13, 79, 11, 110, 10, 111, 12, 12, 13, 78, 79, 11, 12, 13, 78, 78, 79, 95, 78, 78, 78, 79, 79, 78, 11, 13, 95, 95, 79, 95, 79, 78, 79, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 29, 27, 10, 10, 10, 78, 78, 78 }
lower_layer[10] = { 78, 78, 78, 11, 12, 110, 26, 26, 42, 111, 12, 110, 10, 42, 42, 26, 26, 29, 95, 11, 110, 28, 111, 12, 12, 12, 13, 78, 78, 95, 79, 79, 95, 43, 45, 79, 78, 79, 95, 95, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 111, 110, 28, 10, 10, 78, 78, 78 }
lower_layer[11] = { 78, 78, 78, 27, 26, 59, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 61, 111, 78, 43, 44, 126, 28, 28, 28, 127, 45, 78, 78, 79, 78, 79, 79, 78, 79, 95, 79, 95, 79, 78, 79, 11, 12, 13, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 10, 10, 10 }
lower_layer[12] = { 78, 78, 78, 27, 26, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 30, 77, 26, 111, 13, 78, 43, 44, 44, 44, 45, 11, 12, 13, 79, 79, 79, 95, 79, 78, 79, 79, 78, 79, 95, 79, 43, 126, 111, 12, 12, 13, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78 }
lower_layer[13] = { 78, 78, 78, 27, 26, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 127, 126, 111, 12, 13, 11, 12, 13, 11, 110, 10, 111, 12, 12, 13, 79, 78, 79, 79, 79, 79, 95, 79, 78, 78, 43, 44, 126, 28, 111, 13, 78, 78, 78, 78, 95, 95, 78, 78, 78, 78, 78, 78 }
lower_layer[14] = { 42, 78, 78, 43, 126, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 30, 77, 111, 110, 28, 28, 111, 110, 42, 111, 110, 10, 10, 10, 42, 42, 111, 13, 79, 78, 79, 79, 95, 79, 95, 78, 79, 95, 78, 43, 44, 44, 45, 78, 95, 78, 95, 95, 79, 78, 78, 78, 78, 78, 79 }
lower_layer[15] = { 42, 42, 78, 78, 27, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 47, 61, 59, 60, 60, 60, 46, 47, 60, 60, 61, 10, 42, 28, 42, 42, 29, 78, 78, 78, 78, 95, 78, 95, 95, 95, 95, 79, 95, 79, 78, 79, 78, 79, 79, 79, 95, 78, 78, 78, 78, 78, 78, 78 }
lower_layer[16] = { 126, 42, 78, 78, 27, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 15, 77, 91, 63, 76, 76, 31, 76, 76, 14, 47, 61, 127, 126, 28, 127, 45, 79, 78, 95, 95, 95, 78, 79, 95, 79, 79, 78, 79, 78, 79, 78, 79, 79, 11, 12, 13, 78, 11, 12, 13, 78, 78, 78 }
lower_layer[17] = { 27, 42, 78, 11, 110, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 31, 30, 47, 61, 91, 62, 76, 76, 76, 30, 76, 31, 77, 111, 110, 28, 29, 79, 79, 95, 79, 79, 79, 11, 13, 78, 95, 95, 95, 95, 78, 79, 79, 79, 79, 43, 44, 45, 11, 110, 28, 111, 12, 12, 12 }
lower_layer[18] = { 27, 42, 78, 43, 126, 91, 62, 76, 76, 15, 31, 30, 76, 30, 76, 15, 63, 62, 77, 10, 91, 92, 92, 62, 76, 76, 15, 77, 28, 28, 28, 29, 11, 12, 12, 12, 12, 12, 110, 111, 12, 12, 12, 12, 13, 95, 78, 11, 13, 78, 79, 11, 12, 110, 28, 28, 28, 28, 28, 28 }
lower_layer[19] = { 110, 78, 78, 78, 43, 126, 91, 92, 92, 62, 63, 92, 92, 92, 62, 63, 93, 91, 93, 42, 10, 127, 126, 91, 62, 76, 76, 77, 28, 28, 28, 111, 110, 28, 28, 28, 42, 28, 42, 28, 28, 42, 42, 28, 111, 12, 12, 110, 111, 12, 12, 110, 28, 28, 127, 44, 44, 44, 44, 44 }
lower_layer[20] = { 78, 78, 78, 78, 78, 43, 44, 44, 126, 10, 42, 26, 127, 126, 26, 28, 42, 26, 42, 26, 42, 111, 110, 26, 75, 76, 76, 77, 28, 127, 44, 126, 28, 28, 10, 28, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 42, 42, 127, 126, 29, 78, 78, 78, 78, 78 }
lower_layer[21] = { 78, 78, 78, 78, 78, 78, 78, 78, 43, 126, 42, 42, 29, 43, 126, 28, 42, 26, 26, 42, 26, 28, 127, 126, 75, 76, 76, 77, 28, 29, 78, 27, 28, 42, 42, 28, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 42, 42, 42, 111, 110, 111, 13, 78, 78, 78, 78 }
lower_layer[22] = { 78, 78, 78, 78, 78, 78, 78, 78, 11, 110, 42, 26, 111, 12, 110, 26, 127, 44, 126, 42, 10, 127, 45, 27, 75, 76, 76, 77, 127, 45, 11, 110, 28, 28, 28, 28, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 28, 10, 10, 28, 111, 78, 78, 78, 78 }
lower_layer[23] = { 78, 78, 78, 78, 78, 78, 78, 78, 43, 44, 44, 44, 44, 126, 42, 42, 111, 12, 110, 42, 26, 29, 78, 27, 75, 76, 76, 77, 29, 11, 110, 59, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 61, 28, 28, 78, 127, 44, 44, 44 }
lower_layer[24] = { 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 43, 44, 44, 126, 42, 26, 127, 44, 45, 11, 110, 75, 76, 76, 77, 29, 27, 28, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 28, 28, 78, 111, 13, 78, 78 }
lower_layer[25] = { 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 11, 13, 78, 78, 78, 43, 126, 127, 45, 95, 78, 27, 26, 75, 14, 76, 77, 29, 43, 126, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 28, 28, 78, 10, 111, 13, 78 }
lower_layer[26] = { 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 43, 45, 78, 78, 78, 78, 43, 45, 78, 11, 12, 110, 26, 75, 76, 31, 77, 29, 11, 110, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 28, 28, 78, 10, 10, 29, 78 }
lower_layer[27] = { 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 13, 78, 78, 78, 78, 78, 78, 78, 78, 78, 27, 26, 26, 26, 75, 15, 76, 77, 111, 110, 26, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 28, 127, 78, 10, 10, 29, 78 }
lower_layer[28] = { 78, 11, 12, 78, 78, 318, 319, 78, 78, 28, 111, 13, 78, 10, 10, 78, 78, 78, 78, 78, 27, 127, 126, 28, 91, 92, 92, 93, 28, 127, 126, 75, 30, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 127, 45, 78, 10, 10, 29, 78 }
lower_layer[29] = { 78, 27, 59, 60, 78, 334, 335, 78, 78, 28, 127, 45, 78, 10, 10, 78, 78, 78, 78, 11, 110, 111, 110, 28, 28, 28, 26, 26, 127, 45, 27, 91, 62, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 29, 78, 78, 78, 10, 111, 13 }
lower_layer[30] = { 78, 27, 75, 15, 76, 350, 351, 78, 42, 42, 29, 78, 78, 26, 78, 78, 78, 78, 11, 110, 28, 28, 26, 28, 127, 44, 126, 127, 45, 78, 43, 126, 91, 62, 76, 31, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 29, 78, 78, 78, 78, 10, 29 }
lower_layer[31] = { 78, 27, 75, 76, 15, 30, 31, 77, 42, 127, 45, 78, 78, 78, 78, 78, 78, 78, 27, 28, 26, 127, 44, 44, 45, 78, 43, 45, 78, 78, 78, 43, 126, 75, 76, 76, 14, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 29, 78, 78, 78, 78, 78, 111 }
lower_layer[32] = { 78, 27, 91, 92, 62, 76, 14, 77, 42, 111, 13, 78, 78, 78, 78, 78, 78, 11, 110, 26, 127, 45, 78, 78, 11, 13, 78, 78, 78, 78, 78, 78, 27, 91, 92, 92, 62, 31, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 77, 111, 13, 78, 78, 78, 78, 78 }
lower_layer[33] = { 78, 43, 44, 126, 91, 62, 76, 63, 42, 10, 111, 12, 13, 78, 78, 78, 11, 110, 28, 127, 45, 78, 78, 78, 43, 45, 78, 78, 78, 78, 78, 78, 43, 44, 44, 126, 75, 15, 31, 76, 76, 76, 76, 76, 76, 76, 318, 319, 76, 76, 76, 76, 77, 26, 29, 78, 78, 78, 78, 78 }
lower_layer[34] = { 78, 78, 78, 27, 42, 91, 92, 93, 42, 42, 28, 28, 111, 12, 13, 11, 110, 28, 127, 45, 78, 78, 10, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 27, 75, 76, 76, 76, 76, 76, 76, 14, 14, 14, 334, 335, 14, 76, 76, 76, 77, 26, 111, 13, 78, 78, 78, 78 }
lower_layer[35] = { 78, 78, 78, 43, 126, 127, 126, 42, 42, 42, 10, 42, 10, 42, 111, 110, 127, 44, 45, 78, 78, 127, 126, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 11, 13, 27, 91, 92, 62, 30, 76, 76, 76, 76, 76, 14, 350, 351, 76, 76, 76, 14, 77, 28, 26, 111, 13, 78, 78, 78 }
lower_layer[36] = { 78, 78, 78, 78, 43, 45, 43, 126, 42, 127, 44, 44, 44, 44, 44, 44, 45, 78, 78, 78, 78, 29, 43, 126, 78, 78, 78, 78, 78, 78, 78, 78, 11, 110, 29, 27, 26, 26, 75, 76, 76, 31, 76, 76, 76, 76, 76, 76, 76, 76, 15, 31, 77, 28, 127, 44, 45, 78, 78, 78 }
lower_layer[37] = { 126, 78, 78, 78, 78, 78, 78, 43, 44, 45, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 111, 13, 27, 42, 13, 78, 78, 78, 78, 78, 78, 43, 44, 45, 43, 126, 26, 75, 76, 30, 76, 76, 14, 63, 92, 92, 92, 92, 92, 92, 92, 93, 127, 45, 78, 78, 78, 78, 78 }
lower_layer[38] = { 43, 126, 42, 42, 78, 78, 78, 78, 78, 78, 78, 78, 11, 13, 78, 78, 78, 78, 78, 78, 42, 28, 111, 110, 127, 44, 126, 78, 78, 78, 78, 78, 78, 78, 78, 78, 27, 26, 91, 92, 92, 92, 92, 92, 93, 10, 127, 44, 44, 44, 44, 44, 44, 45, 78, 78, 78, 78, 78, 78 }
lower_layer[39] = { 78, 43, 44, 44, 126, 42, 78, 78, 78, 78, 78, 78, 43, 45, 78, 78, 78, 78, 78, 42, 42, 28, 28, 28, 29, 78, 43, 126, 78, 78, 78, 78, 78, 78, 78, 78, 43, 126, 26, 42, 26, 42, 26, 127, 44, 44, 45, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 78, 28 }

-- The middle tile layer. The numbers are indeces to the tile_mappings table.
middle_layer = {}
middle_layer[0] = { -1, -1, -1, -1, 249, 250, -1, -1, -1, -1, 233, 234, -1, -1, -1, -1, -1, -1, -1, 57, 144, -1, 64, 65, 68, 69, 96, 97, 98, 99, 86, 87, 82, 83, 70, 71, 66, 67, 66, 67, 66, 67, 54, -1, -1, 57, 54, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
middle_layer[1] = { 66, 67, 66, 67, 54, -1, -1, -1, -1, -1, 249, 250, -1, -1, 235, -1, -1, 57, 72, 73, 160, 161, 80, 81, 84, 85, -1, -1, -1, -1, 102, 103, 98, 99, 86, 87, 82, 83, 82, 83, 82, 83, 70, 71, 72, 73, 70, 71, 66, 67, 66, 67, 54, -1, -1, -1, -1, -1, -1, -1 }
middle_layer[2] = { 82, 83, 82, 83, 70, 71, 144, -1, -1, -1, -1, 252, -1, -1, 251, -1, 72, 73, 88, 89, 176, 177, 96, 97, 100, 101, -1, -1, -1, -1, -1, 251, -1, -1, 102, 103, 98, 99, 98, 99, 98, 99, 86, 87, 88, 89, 86, 87, 82, 83, 82, 83, 70, 71, 144, -1, -1, -1, -1, -1 }
middle_layer[3] = { 98, 99, 98, 99, 86, 87, 160, 161, 252, -1, -1, -1, -1, -1, 194, 195, 88, 89, 104, 105, 64, 65, 66, 67, 54, -1, -1, -1, -1, -1, -1, -1, -1, 57, 66, 67, 66, 67, 66, 67, 54, -1, 102, 103, 104, 105, 102, 103, 98, 99, 98, 99, 86, 87, 160, 161, -1, -1, -1, -1 }
middle_layer[4] = { -1, 252, -1, -1, 102, 103, 176, 177, -1, 57, 66, 67, 66, 67, 210, 211, 104, 105, -1, -1, 80, 81, 82, 83, 70, 71, 252, -1, 247, 248, 66, 67, 72, 73, 82, 83, 82, 83, 82, 83, 70, 71, -1, -1, -1, -1, -1, 249, 250, -1, -1, -1, 102, 103, 176, 177, -1, -1, -1, -1 }
middle_layer[5] = { 252, -1, -1, -1, -1, -1, 64, 65, 72, 73, 82, 83, 82, 83, 226, 227, 252, -1, -1, -1, 96, 97, 98, 99, 86, 87, 192, 193, 194, 195, 82, 83, 88, 89, 98, 99, 98, 99, 98, 99, 86, 87, 192, 193, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 32, 33, -1, -1, -1, -1 }
middle_layer[6] = { -1, 251, -1, -1, -1, -1, 80, 81, 88, 89, 98, 99, 98, 99, 242, 243, -1, -1, -1, -1, -1, -1, -1, -1, 102, 103, 208, 209, 210, 211, 98, 99, 104, 105, -1, -1, -1, -1, -1, -1, 102, 103, 208, 209, 66, 67, 54, -1, -1, -1, -1, -1, -1, -1, 48, 49, -1, -1, -1, -1 }
middle_layer[7] = { 252, -1, -1, 244, 245, 246, 96, 97, 104, 105, 247, 248, -1, -1, 251, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 224, 225, 226, 227, -1, 228, 229, 230, -1, -1, -1, -1, 244, 245, 246, -1, 224, 225, 82, 83, 70, 71, 66, 67, 144, -1, -1, -1, 64, 65, 144, -1, -1, -1 }
middle_layer[8] = { -1, 252, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 240, 241, 242, 243, -1, 244, 245, 246, -1, -1, -1, -1, -1, -1, -1, -1, 240, 241, 98, 99, 86, 87, 82, 83, 160, 161, -1, -1, 80, 81, 192, 193, -1, -1 }
middle_layer[9] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 249, 250, -1, -1, -1, -1, -1, -1, -1, -1, 102, 103, 98, 99, 176, 177, -1, -1, 96, 97, 208, 209, 66, 67 }
middle_layer[10] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 247, 248, -1, -1, -1, 48, 49, -1, -1, -1, -1, 224, 225, 82, 83 }
middle_layer[11] = { -1, -1, -1, -1, -1, -1, -1, -1, 290, 291, 292, 293, 294, 295, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 249, 250, 64, 65, 66, 67, 66, 67, 54, 241, 98, 99 }
middle_layer[12] = { -1, -1, -1, -1, -1, -1, -1, 305, 306, 307, 308, 309, 310, 311, 312, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 80, 81, 82, 83, 82, 83, 70, 71, 66, 67 }
middle_layer[13] = { -1, -1, -1, -1, -1, -1, -1, 321, 322, 323, 324, 325, 326, 327, 328, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 96, 97, 98, 99, 98, 99, 86, 87, 82, 83 }
middle_layer[14] = { -1, -1, -1, -1, -1, -1, -1, 337, 338, 339, 268, 269, 342, 343, 344, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 102, 103, 98, 99 }
middle_layer[15] = { -1, -1, 36, 37, -1, -1, -1, 353, 354, 355, 284, 285, 358, 359, 360, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 244, 245, 246, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
middle_layer[16] = { -1, -1, 52, 53, -1, -1, -1, 369, 370, 371, 300, 301, 374, 375, 376, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 251, -1, 251, -1, 251, -1 }
middle_layer[17] = { -1, -1, 36, 37, -1, -1, -1, 385, 386, 387, 316, 317, 390, 391, 392, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 249, 250, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
middle_layer[18] = { -1, -1, 52, 53, -1, -1, -1, 401, 402, 403, 404, 405, 406, 407, 408, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
middle_layer[19] = { -1, 147, 68, 69, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
middle_layer[20] = { 162, 163, 84, 85, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 251, -1, 251, -1, 251, -1 }
middle_layer[21] = { 178, 179, 100, 101, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 289, 290, 291, 292, 293, 292, 293, 294, 294, 292, 293, 292, 293, 292, 293, 294, 295, -1, -1, -1, -1, -1, 1, 2, 3, 2, 3 }
middle_layer[22] = { 163, 69, -1, 290, 291, 292, 293, 294, 295, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 305, 306, 307, 308, 309, 512, 513, 516, 310, 308, 309, 308, 309, 308, 309, 310, 311, 312, -1, -1, -1, 16, 17, 18, 19, 18, 19 }
middle_layer[23] = { 179, 85, 305, 306, 307, 308, 309, 310, 311, 312, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 321, 322, 323, 324, 325, 324, 529, 530, 531, 292, 325, 324, 325, 324, 325, 326, 327, 328, -1, -1, -1, 32, 33, -1, -1, -1, -1 }
middle_layer[24] = { 37, -1, 321, 322, 323, 324, 325, 326, 327, 328, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 337, 418, 419, 266, 267, 544, 545, 546, 547, 308, 309, 308, 309, 308, 309, 310, 311, 312, -1, -1, -1, 48, 49, -1, -1, -1, -1 }
middle_layer[25] = { 53, -1, 417, 418, 419, 270, 271, 422, 423, 424, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 433, 434, 435, 282, 283, 560, 561, 562, 563, 324, 325, 324, 325, 324, 325, 326, 327, 328, -1, -1, -1, 32, 33, -1, 196, 197, 198 }
middle_layer[26] = { 69, -1, 433, 434, 435, 286, 287, 438, 439, 440, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 449, 450, 451, 298, 299, 576, 577, 578, 579, 308, 309, 308, 309, 308, 309, 310, 311, 312, -1, -1, -1, 48, 49, -1, 228, 229, 230 }
middle_layer[27] = { 85, -1, 449, 450, 451, 302, 303, 454, 455, 456, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 466, 467, 314, 315, 592, 593, 594, 595, 324, 325, 324, 325, 324, 325, 326, 327, 328, -1, -1, -1, 32, 33, -1, 244, 245, 246 }
middle_layer[28] = { -1, -1, 465, 466, 467, 366, 367, 470, 471, 472, -1, 48, 49, -1, -1, 36, 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 481, 482, 483, 330, 331, 609, 305, 306, 307, 308, 309, 308, 309, 308, 309, 310, 311, 312, -1, -1, -1, 48, 49, -1, -1, -1, -1 }
middle_layer[29] = { -1, -1, 481, 482, 483, 382, 383, 486, 487, 488, -1, 32, 33, -1, -1, 52, 53, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 497, 498, 499, 346, 347, 625, 321, 322, 323, 324, 325, 324, 325, 324, 325, 326, 327, 328, -1, -1, -1, 64, 65, 144, -1, -1, -1 }
middle_layer[30] = { -1, -1, 497, 498, 499, 398, 399, 502, 503, 504, -1, 48, 49, -1, 57, 68, 69, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 417, 418, 419, 266, 267, 420, 421, 270, 271, 422, 423, 424, -1, -1, -1, 80, 81, 192, 193, -1, -1 }
middle_layer[31] = { -1, 252, 254, 255, -1, -1, -1, -1, -1, -1, -1, 64, 65, 72, 73, 84, 85, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 433, 434, 435, 282, 283, 436, 437, 286, 287, 438, 439, 440, -1, -1, -1, 96, 97, 208, 209, 144, -1 }
middle_layer[32] = { 252, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 80, 81, 88, 89, 100, 101, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 449, 450, 451, 298, 299, 452, 453, 302, 303, 454, 455, 456, -1, -1, -1, -1, -1, 224, 225, 160, 161 }
middle_layer[33] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 96, 97, 104, 105, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 465, 466, 467, 314, 315, 468, 469, 366, 367, 470, 471, 472, -1, -1, -1, -1, -1, 240, 241, 176, 177 }
middle_layer[34] = { 36, 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 481, 482, 483, 330, 331, 484, 485, 382, 383, 486, 487, 488, -1, -1, -1, -1, -1, -1, -1, 32, 33 }
middle_layer[35] = { 52, 53, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 33, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 497, 498, 499, 346, 347, 500, 501, 398, 399, 502, 503, 504, -1, -1, -1, -1, -1, -1, -1, 48, 49 }
middle_layer[36] = { 114, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 49, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 32, 33 }
middle_layer[37] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 40, 41, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 253, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 48, 49 }
middle_layer[38] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 249, 250, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 114, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 112, 113 }
middle_layer[39] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 33, -1, -1, -1, -1, -1, -1, -1, -1, -1, 131, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, 17, 128, -1 }

-- The upper tile layer. The numbers are indeces to the tile_mappings table.
upper_layer = {}
upper_layer[0] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[1] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 235, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 215, 216, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[2] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 215, 216, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 231, 232, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[3] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 231, 232, -1, -1, -1, -1, -1, -1, 252, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 233, 234, -1, -1, 196, 197, 198, -1, -1, -1, -1, -1, -1 }
upper_layer[4] = { -1, -1, -1, 196, 197, 198, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 212, 213, 214, -1, -1, -1, -1, -1, -1 }
upper_layer[5] = { -1, 235, -1, 212, 213, 214, -1, -1, -1, -1, 215, 216, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 196, 197, 198, -1, -1, -1, -1, 196, 197, 198, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 228, 229, 230, -1, -1, 215, 216, -1, -1 }
upper_layer[6] = { -1, -1, -1, 228, 229, 230, -1, -1, -1, -1, 231, 232, -1, -1, 235, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 212, 213, 214, -1, -1, 215, 216, 228, 229, 214, -1, -1, -1, -1, -1, -1, 252, -1, -1, -1, 244, 245, 246, -1, -1, 231, 232, -1, -1 }
upper_layer[7] = { 21, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 231, 232, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 247, 248, -1, -1 }
upper_layer[8] = { 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 233, 234, -1, -1, -1, -1, -1, -1, -1, 215, 216, -1, 215, 216, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[9] = { 53, -1, -1, -1, -1, -1, -1, 257, 258, -1, 260, 261, -1, 263, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 231, 232, -1, 231, 232, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[10] = { 115, 21, -1, -1, -1, -1, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 233, 234, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[11] = { 36, 37, -1, -1, -1, -1, 288, 289, -1, -1, -1, -1, -1, -1, 296, 297, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 240, -1, -1, -1 }
upper_layer[12] = { 52, 53, -1, -1, -1, -1, 304, 305, -1, -1, -1, -1, -1, -1, 312, 313, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 196, 197, 198, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[13] = { 114, 115, 4, -1, -1, -1, 320, 321, -1, -1, -1, -1, -1, -1, 328, 329, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 212, 213, 214, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[14] = { -1, 131, 20, 21, -1, -1, 336, 337, -1, -1, -1, -1, -1, -1, 344, 345, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 228, 229, 230, -1, -1, -1, -1, 215, 216, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[15] = { -1, -1, -1, -1, -1, -1, 352, 353, -1, -1, -1, -1, -1, -1, 360, 361, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 231, 232, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 235, -1, 235, -1, 235, -1 }
upper_layer[16] = { -1, -1, -1, -1, -1, -1, 368, -1, -1, -1, -1, -1, -1, -1, -1, 377, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 233, 234, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[17] = { -1, -1, -1, -1, -1, -1, 384, -1, -1, -1, -1, -1, -1, -1, -1, 393, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[18] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[19] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 257, 258, -1, 260, 261, 260, 261, -1, -1, 260, 261, 260, 261, 260, 261, -1, 263, 264, -1, -1, -1, 235, -1, 235, -1, 235, -1 }
upper_layer[20] = { -1, -1, 257, 258, -1, 260, 261, -1, 263, 264, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 272, 273, 274, 275, 276, 277, 276, 277, 278, 278, 276, 277, 276, 277, 276, 277, 278, 279, 280, 281, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[21] = { -1, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 288, 289, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 296, 297, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[22] = { -1, 288, 289, -1, -1, -1, -1, -1, -1, 296, 297, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 304, 305, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 312, 313, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[23] = { -1, 304, 305, -1, -1, -1, -1, -1, -1, 312, 313, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 320, 321, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 328, 329, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[24] = { -1, 320, 321, -1, -1, -1, -1, -1, -1, 328, 329, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 336, 337, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 312, 313, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[25] = { -1, 416, 337, -1, -1, -1, -1, -1, -1, 344, 425, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 352, 353, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 328, 329, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[26] = { -1, 432, 353, -1, -1, -1, -1, -1, -1, 360, 441, -1, 1, 2, 3, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 448, 369, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 312, 313, -1, -1, -1, 215, 216, -1, -1, -1 }
upper_layer[27] = { -1, 448, -1, -1, -1, -1, -1, -1, -1, -1, 457, 16, 17, 18, 19, 20, 21, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 464, 465, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 328, 329, -1, -1, -1, 231, 232, -1, -1, -1 }
upper_layer[28] = { -1, 464, -1, -1, -1, -1, -1, -1, -1, -1, 473, -1, 252, 215, 216, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 336, 305, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 312, 313, -1, -1, -1, 247, 248, -1, -1, -1 }
upper_layer[29] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 231, 232, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 352, 321, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 328, 329, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[30] = { 21, -1, 238, 239, -1, -1, -1, -1, -1, -1, -1, -1, -1, 247, 248, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 416, 337, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 344, 425, -1, -1, -1, -1, -1, 252, -1, -1 }
upper_layer[31] = { 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 432, 353, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 360, 441, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[32] = { 53, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, 17, 20, 21, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 448, 369, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 376, 457, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[33] = { 115, 21, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 1, 112, 113, 36, 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 464, 465, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 472, 473, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[34] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, 17, 128, -1, 52, 53, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[35] = { -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 215, 216, -1, -1, -1, -1, -1, -1, -1, 32, -1, -1, -1, 114, 115, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[36] = { -1, 115, 2, 3, 8, 9, -1, -1, -1, -1, 231, 232, -1, -1, -1, -1, -1, -1, -1, 48, -1, -1, -1, -1, 131, 24, 25, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 237, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[37] = { -1, 131, 18, 19, 24, 25, 8, 9, -1, -1, 233, 234, -1, -1, -1, -1, -1, -1, 1, 112, 113, -1, -1, -1, -1, -1, -1, 20, 21, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[38] = { -1, -1, -1, -1, 40, 41, 24, 25, 4, -1, -1, -1, -1, -1, -1, -1, -1, 16, 17, 128, 196, 197, 198, -1, -1, -1, -1, -1, 115, 4, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }
upper_layer[39] = { -1, -1, -1, -1, -1, -1, 40, 41, 20, 21, -1, -1, -1, -1, -1, -1, -1, 32, -1, -1, 212, 213, 214, -1, -1, -1, -1, -1, -1, 20, 21, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 }

-- Other global variables for the map script to use
laila = nil; -- Pointer to Laila's map sprite

function Load(m)
	-- First, record the current map in the "map" variable that is global to this script
	map = m;
	map._run_forever = true;

	local sprite;
	local dialogue;
	local action;
	local chest;

	-- Create the player's sprite
	sprite = hoa_map.MapSprite();
	sprite:SetName("Claudius");
	sprite:SetObjectID(1000);
	sprite:SetContext(1);
	sprite:SetXPosition(100, 0.5);
	sprite:SetYPosition(36, 0.5);
	sprite:SetCollHalfWidth(0.95);
	sprite:SetCollHeight(1.9);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.NORMAL_SPEED);
	sprite:SetDirection(8);
	sprite:LoadStandardAnimations("img/sprites/map/claudius_walk.png");
	sprite:LoadRunningAnimations("img/sprites/map/claudius_run.png");
	sprite:SetFacePortrait("img/portraits/map/claudius.png");
	map:_AddGroundObject(sprite);

	-- Set the camera to focus on the player's sprite
	map:_SetCameraFocus(sprite);

	-- Create a NPC sprite
	sprite = hoa_map.MapSprite();
	sprite:SetName("Laila");
	sprite:SetObjectID(2);
	sprite:SetContext(1);
	sprite:SetXPosition(105, 0.0);
	sprite:SetYPosition(32, 0.0);
	sprite:SetCollHalfWidth(0.95);
	sprite:SetCollHeight(1.9);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.SLOW_SPEED);
	sprite:SetDirection(2);
	sprite:LoadStandardAnimations("img/sprites/map/laila_walk.png");
	sprite:LoadRunningAnimations("img/sprites/map/laila_run.png");
	sprite:SetFacePortrait("img/portraits/map/laila.png");

	dialogue = hoa_map.MapDialogue();
	--dialogue:SetMaxViews(1);
	dialogue:AddText("Laila, what's wrong? You have a worried look on your face.", 1000, -1, -1); --Line 0
	dialogue:AddText("You're going into the cave again, aren't you?", 2, -1, -1); --Line 1
	dialogue:AddOption("Yes, I intend to...", 1000, 2, -1);
	dialogue:AddOption("No, of course not...", 1000, 8, -1);
	
	--Yes
	dialogue:AddText("But why? Its dangerous in there!", 2, -1, -1); --Line 2
	dialogue:AddText("Laila, if I want to be capable on the battlefield I have to fight real battles. You understand that, don't you?", 1000, -1, -1); --Line 3
	dialogue:AddText("I know that you're worried about me and I appreciate it, but you need to stop doing this.", 1000, -1, -1); --Line 4
	dialogue:AddText(".....Alright, I'm sorry. Just be careful in there, okay?", 2, -1, -1); --Line 5
	dialogue:AddText("Will do. Thanks Laila.", 1000, -1, -1); --Line 6
	dialogue:AddText("You know Claudius, I could be of assistance to you in the cave. May I come with you?", 2, -1, -1); --Line 7
	dialogue:AddOption("No way, you could be hurt!", 1000, 10 , -1);
	dialogue:AddOption("Your help would be great!", 1000, 12 , -1);
	
	--No
	dialogue:AddText("Oh good. I was worried you were. Please tell me if you are Cladius, just so I can know...", 2, -1,-1); --Line 8
	dialogue:AddText("Of course, I promise.", 1000, -1, -1); --Line 9
	dialogue:EndDialogue();
	
	-- Rejected
	dialogue:AddText("Oh....ok then. You remember to be careful.", 2, -1, -1); -- Line 10
	dialogue:AddText("I will Laila.", 1000, -1, -1); -- Line 11
	dialogue:EndDialogue();
	
	-- Add to party
	dialogue:AddText("Great, I'll be sure to help you any way I can.", 2, -1, 1); --  Line 12, Laila added to party and map sprite removed
	dialogue:AddText("Laila has joined the party.", 2, -1, -1); -- Line 13
	sprite:AddDialogue(dialogue);
	
	laila = sprite;
	-- If Laila previously joined the party in the saved game, remove her sprite
	if (map._map_event_group:DoesEventExist("laila_joined") == true) then
		map_functions[1]();
	end

	action = hoa_map.ActionAnimate(sprite);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_WEST, 1000);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_NORTH, 1000);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_EAST, 1000);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_NORTH, 1000);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_WEST, 1000);
	action:SetLoops(0);
	sprite:AddAction(action);

	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(105, 44);
	sprite:AddAction(action);

	action = hoa_map.ActionAnimate(sprite);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_WEST, 1000);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_SOUTH, 1000);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_EAST, 1000);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_SOUTH, 1000);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_WEST, 1000);
	action:SetLoops(0);
	sprite:AddAction(action);

	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(105, 32);
	sprite:AddAction(action);

	sprite.current_action = 0;
	map:_AddGroundObject(sprite);

	sprite = hoa_map.MapSprite();
	sprite:SetName("Marcus");
	sprite:SetObjectID(3);
	sprite:SetContext(1);
	sprite:SetXPosition(40, 0.7);
	sprite:SetYPosition(35, 0.2);
	sprite:SetCollHalfWidth(0.95);
	sprite:SetCollHeight(1.9);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.VERY_SLOW_SPEED);
	sprite:SetDirection(2);
	sprite:LoadStandardAnimations("img/sprites/map/marcus_walk.png");
	sprite:SetFacePortrait("img/portraits/map/marcus.png");

	dialogue = hoa_map.MapDialogue();
	dialogue:AddText("Hey there son, how's the training going?", 3, -1, -1);
	dialogue:AddText("Pretty well. The enemies in the cave aren't too tough.", 1000, -1, -1);
	dialogue:AddText("Good to hear. Don't let your guard down though. The deeper you go into that cave, the more likely it is that you'll face stronger opponents.", 3, -1, -1);
	sprite:AddDialogue(dialogue);

	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(50, 35);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(40, 35);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(88, 26);
	sprite:AddAction(action);
	sprite.current_action = 0;
	map:_AddGroundObject(sprite);

	sprite = hoa_map.MapSprite();
	sprite:SetName("Vanica");
	sprite:SetObjectID(4);
	sprite:SetContext(1);
	sprite:SetXPosition(38, 0.5);
	sprite:SetYPosition(60, 0.5);
	sprite:SetCollHalfWidth(0.95);
	sprite:SetCollHeight(1.9);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.VERY_SLOW_SPEED);
	sprite:SetDirection(2);
	sprite:LoadStandardAnimations("img/sprites/map/vanica_walk.png");
	sprite:SetFacePortrait("img/portraits/map/vanica.png");

	dialogue = hoa_map.MapDialogue();
	dialogue:SetMaxViews(1);
	dialogue:AddText("Oh, Claudius? You seemed puzzled.", 4, -1, -1);
	dialogue:AddText("There are odd little icons above people's heads. What do they mean?", 1000, -1, -1);
	dialogue:AddText("That is a new dialogue indicator. Any person that has something new to say that you haven't already heard will have that icon above their head. Once you've listened to everything that they have to say, the icon will disappear.", 4, -1, -1);
	sprite:AddDialogue(dialogue);

	dialogue = hoa_map.MapDialogue();
	dialogue:AddText("And remember that a person may have more thing to say, so if the icon doesn't disappear after speaking to a person, speak to them once more.", 4, -1, -1);
	sprite:AddDialogue(dialogue);

	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(38, 38);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(38, 60);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(35, 48);
	sprite:AddAction(action);
	sprite.current_action = 0;
	map:_AddGroundObject(sprite);

	sprite = hoa_map.MapSprite();
	sprite:SetName("Laine");
	sprite:SetObjectID(6);
	sprite:SetContext(1);
	sprite:SetXPosition(72, 0.5);
	sprite:SetYPosition(25, 0.5);
	sprite:SetCollHalfWidth(0.95);
	sprite:SetCollHeight(1.9);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.SLOW_SPEED);
	sprite:SetDirection(2);
	sprite:LoadStandardAnimations("img/sprites/map/man_npc01_walk.png");

	dialogue = hoa_map.MapDialogue();
	dialogue:AddText("Hello, would you happen to know why it seems impossible to enter any of these houses?", 1000, -1, -1);
	dialogue:AddText("Ah, well the game designers are still working on decorating the interiors, so they had to lock the doors to make sure that no one soiled the place before they were finished.", 6, -1, -1);
	sprite:AddDialogue(dialogue);

	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(72, 40);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(44, 40);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(60, 54);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(62, 62);
	sprite:AddAction(action);
	action = hoa_map.ActionAnimate(sprite);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_EAST, 1500);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_NORTH, 10000);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(46, 56);
	sprite:AddAction(action);
	sprite.current_action = 0;
	map:_AddGroundObject(sprite);

	sprite = hoa_map.MapSprite();
	sprite:SetName("Alexander");
	sprite:SetObjectID(7);
	sprite:SetContext(1);
	sprite:SetXPosition(52, 0.5);
	sprite:SetYPosition(35, 0.5);
	sprite:SetCollHalfWidth(0.95);
	sprite:SetCollHeight(1.9);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.SLOW_SPEED);
	sprite:SetDirection(2);
	sprite:LoadStandardAnimations("img/sprites/map/man_npc02_walk.png");

	dialogue = hoa_map.MapDialogue();
	dialogue:AddText("Choose your target wisely in battle. Its best to single out and take down one foe at a time. And don't be afraid to use a healing potion or two in battle if you're feeling weak.", 7, -1, -1);
	sprite:AddDialogue(dialogue);

	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(52, 25);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(52, 55);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(31, 25);
	sprite:AddAction(action);
	action = hoa_map.ActionPathMove(sprite);
	action:SetDestination(40, 55);
	sprite:AddAction(action);
	sprite.current_action = 0;
	map:_AddGroundObject(sprite);

	sprite = hoa_map.MapSprite();
	sprite:SetName("Torl");
	sprite:SetObjectID(8);
	sprite:SetContext(1);
	sprite:SetXPosition(40, 0.5);
	sprite:SetYPosition(20, 0.5);
	sprite:SetCollHalfWidth(0.95);
	sprite:SetCollHeight(1.9);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.VERY_FAST_SPEED);
	sprite:SetDirection(2);
	sprite:LoadStandardAnimations("img/sprites/map/boy_npc01_walk.png");

	dialogue = hoa_map.MapDialogue();
	dialogue:AddText("This village is boring! There's no one I can play with here!", 8, -1, -1);
	sprite:AddDialogue(dialogue);

	action = hoa_map.ActionRandomMove(sprite);
	sprite:AddAction(action);
	sprite.current_action = 0;
	map:_AddGroundObject(sprite);

	sprite = hoa_map.MapSprite();
	sprite:SetName("Female Merchant");
	sprite:SetObjectID(9);
	sprite:SetContext(1);
	sprite:SetXPosition(70, 0.5);
	sprite:SetYPosition(60, 0.5);
	sprite:SetCollHalfWidth(0.95);
	sprite:SetCollHeight(1.9);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.SLOW_SPEED);
	sprite:SetDirection(2);
	sprite:LoadStandardAnimations("img/sprites/map/woman_npc01_walk.png");

	dialogue = hoa_map.MapDialogue();
	dialogue:AddText("I have merchandise for sale at affordable prices. Take a look.", 9, -1, 0);
	sprite:AddDialogue(dialogue);

	action = hoa_map.ActionAnimate(sprite);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_WEST, 1250);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_SOUTH, 1250);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_EAST, 1250);
	action:AddFrame(hoa_map.MapMode.ANIM_STANDING_SOUTH, 1000);
	action:SetLoops(-1);
	sprite:AddAction(action);
	sprite.current_action = 0;
	map:_AddGroundObject(sprite);

	sprite = hoa_map.MapSprite();
	sprite:SetName("Livia");
	sprite:SetObjectID(10);
	sprite:SetContext(1);
	sprite:SetXPosition(32, 0.5);
	sprite:SetYPosition(29, 0.5);
	sprite:SetCollHalfWidth(0.95);
	sprite:SetCollHeight(1.9);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.SLOW_SPEED);
	sprite:SetDirection(2);
	sprite:LoadStandardAnimations("img/sprites/map/girl_npc02_walk.png");

	dialogue = hoa_map.MapDialogue();
	dialogue:AddText("I'm looking for my brother Torl. I sure hope he doesn't get into any trouble.", 10, -1, -1);
	sprite:AddDialogue(dialogue);

	action = hoa_map.ActionRandomMove(sprite);
	sprite:AddAction(action);
	sprite.current_action = 0;
	map:_AddGroundObject(sprite);

	sprite = hoa_map.MapSprite();
	sprite:SetName("Octavia");
	sprite:SetObjectID(11);
	sprite:SetContext(1);
	sprite:SetXPosition(9, 0.5);
	sprite:SetYPosition(35, 0.5);
	sprite:SetCollHalfWidth(1.0);
	sprite:SetCollHeight(2.0);
	sprite:SetImgHalfWidth(1.0);
	sprite:SetImgHeight(4.0);
	sprite:SetMovementSpeed(hoa_map.MapMode.NORMAL_SPEED);
	sprite:SetDirection(2);
	sprite:LoadStandardAnimations("img/sprites/map/woman_npc02_walk.png");

	dialogue = hoa_map.MapDialogue();
	dialogue:AddText("So much work to do!", 11, -1, -1);
	sprite:AddDialogue(dialogue);

	action = hoa_map.ActionRandomMove(sprite);
	sprite:AddAction(action);
	sprite.current_action = 0;
	map:_AddGroundObject(sprite);

	-- Add a treasure just near the town's exit zone
	chest = hoa_map.MapTreasure("img/misc/chest1.png", 4);
	chest:SetObjectID(12);
	chest:SetContext(1);
	chest:SetXPosition(111, 0);
	chest:SetYPosition(34, 0);
	chest:AddDrunes(100);
	chest:AddObject(1, 2); -- Adds 2 Healing Potions
	map:_AddGroundObject(chest);

	-- Create a zone for exiting the map, to be used as a trigger
	exit_zone = hoa_map.MapZone();
	-- Add a section to the zone that goes from (20, 10) to (50, 40) in map grid coordinates
	exit_zone:AddSection(hoa_map.ZoneSection(118, 30, 119, 40));
	map:_AddZone(exit_zone);
end -- function Load()

function Update()
	-- Check if the map camera is in the exit zone
	if (exit_zone:IsInsideZone(map._camera.x_position, map._camera.y_position) == true) then
		ModeManager:Pop();
		local cave_map = hoa_map.MapMode("dat/maps/demo_cave.lua");
		ModeManager:Push(cave_map);
	end
end

function Draw()
	map:_DrawMapLayers();
end

map_functions = {}

-- Creates a new shop mode instance
map_functions[0] = function()
	local shop = hoa_shop.ShopMode();
	shop:AddObject(1); -- Healing Potion
	shop:AddObject(10002); -- Iron Sword
	shop:AddObject(10502); -- Standard Crossbow
	shop:AddObject(20002); -- Cobalt Helm
	shop:AddObject(20502); -- Winged Circlet
	shop:AddObject(30002); -- Leather Chain Mail
	shop:AddObject(40002); -- Phoenix Shield
	shop:AddObject(50502); -- Leather Boots
	ModeManager:Push(shop);
end

-- Add's Laila to the party and removes her sprite from the map
map_functions[1] = function()
	if (map._map_event_group:DoesEventExist("laila_joined") == false) then
		map._map_event_group:AddNewEvent("laila_joined", 1);
		GlobalManager:AddCharacter(hoa_global.GameGlobal.GLOBAL_CHARACTER_LAILA);
	end	

	laila:SetVisible(false);
	laila:SetNoCollision(true);
	laila:SetUpdatable(false);
	laila:SetXPosition(0, 0.0);
	laila:SetXPosition(0, 0.0);	
end
